//
//  queues.c
//  
//
//  Created by Bac Alexandra on 25/10/2021.
//

#include "queues.h"
#include <assert.h>

void qcreate_empty_queue (queue * pq)
{
	queue tmp ;
	tmp.out = create_empty_list () ;
	tmp.in = tmp.out ;
	*pq = tmp ;
}

bool qis_empty_queue (queue * pq)
{
	return is_empty_list(pq->out) ;
}

void qpush_back (Data e, queue * pq)
{
	// Create a new link containing e
	link * tmp = add(e, create_empty_list()) ;
	if (is_empty_list(pq->out))
	{
		pq->out = tmp ;
		pq->in = tmp ;
	}
	else
	{
		// Link it to the end of the queue
		pq->in->next = tmp ;
		// Change the in of the queue to this new link
		pq->in = tmp ;
	}
}

Data qpop_front (queue * pq)
{
	assert(!is_empty_list(pq->out)) ;
	
	// Get the top element and save next link
	Data tmp = head(pq->out) ;
	link * tmpl = tail(pq->out) ;
	// Free the head link
	free_link(pq->out) ;
	// Set the out of the queue to next link
	pq->out = tmpl ;
	// If the queue became empty -> update in as well
	if (is_empty_list(pq->out))
		pq->in = pq->out ;
	// Return top element
	return tmp ;
}

Data qhead(queue * pq)
{
	return head(pq->out);
}

// Memory management

void qfree_queue (queue * pq)
{
	while(!is_empty_list(pq->out))
		qpop_front(pq) ;
}

// I/O

void qprint_queue(queue q)
{
	printf("out -- in : ") ;
	print_list(q.out) ;
}
